/*
 * (!c) 2002 by Ighighi
 * Venezuela
 * 
 * TODO:
 *   Handle PPP subprotocols
 */

#include <stdio.h>

#include "net/ppp.h"

#include "types.h"

void dump_hex(const u8 *packet, int length);
void dump_ip (const u8 *packet, int length);
#if 0
void dump_ip6(const u8 *packet, int length);
#endif

#ifndef PPP_HDRLEN
#define PPP_HDRLEN	4
#endif

void dump_ppp(const u8 *packet, int length)
{
    u16 protocol;
    int i = 1;
    
    printf("  PPP: ");

#ifdef DEBUG    
    if (! packet) {
	printf("DEBUG: We got no packet!\n");
	return;
    }
#endif    

    /* Check the length received */
    if (length < PPP_HDRLEN) {
	printf("ERROR: Truncated PPP: %u\n", length);
	dump_hex(packet, length);
	return;
    }
    
    protocol = *packet;
    if (! (protocol & 01)) {
	protocol &= *(packet + 1) << 8;
	i++;
    }
    
    switch (protocol) {
    case PPP_IP:
    case PPP_IPV6:
	break;
    default:
	printf("proto=%04x ", protocol);
    }
    
    for (; i < length; i++) {
	printf("%02x ", *(packet + i));
    }
    
    packet += PPP_HDRLEN;
    length -= PPP_HDRLEN;

    switch (protocol) {
    case PPP_IP:
	dump_ip(packet, length);
	break;
#if 0
    case PPP_IPV6:
	dump_ip6(packet, length);
	break;
#endif
    default:
	dump_hex(packet, length);
    }
    
    return;
}
