/*
 * (!c) 2002 by Ighighi
 * Venezuela
 */

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>

void dump_time(const struct timeval *now)
{
    static struct timeval old = { 0, 0 };
    struct tm tm, *tp;
    
    printf("\n TIME: ");

#ifdef DEBUG    
    if (! now) {
	printf("DEBUG: We got no now!\n");
	return;
    }
#endif

    /* print timestamp */    
    memcpy(&tm, localtime(&(now->tv_sec)), sizeof(tm));
    printf("%02d:%02d:%02d.%06ld ", tm.tm_hour,
	   tm.tm_min, tm.tm_sec, now->tv_usec);

    /* print time diff */
    if (old.tv_sec || old.tv_usec) {
	tp = localtime(&(old.tv_sec));
	old.tv_usec = now->tv_usec - old.tv_usec;
	if (old.tv_usec < 0) {
	    old.tv_usec += 1000000;
	    tm.tm_sec--;
	}
	tm.tm_sec -= tp->tm_sec;
	if (tm.tm_sec < 0) {
	    tm.tm_sec += 60;
	    tm.tm_min--;
	}
	tm.tm_min -= tp->tm_min;
	if (tm.tm_min < 0) {
	    tm.tm_min += 60;
	    tm.tm_hour--;
	}
	tm.tm_hour -= tp->tm_hour;
	if (tm.tm_hour < 0) {
	    tm.tm_hour += 24;
	}
	printf("(%02d:%02d:%02d.%06ld) ", tm.tm_hour,
	       tm.tm_min, tm.tm_sec, old.tv_usec);
    }
    else {
	printf("                  ");
    }

    putchar('\n');

    /* save time */
    memcpy(&old, now, sizeof(old));
    
    return;
}
