/*
 * (!c) 2002 by Ighighi
 * Venezuela
 */

#include <stdio.h>

#include <netinet/in.h>		/* ntohl() */

#include "types.h"

int gmt2local(void);

/*
 * This function takes a 32-bit timestamp in milliseconds since midnight UT
 * (in network byte order) and returns an ascii string in the format
 * "hh:mm:ss.mmm", where `hh' is the number of hours, `mm' the number of
 * minutes, `ss' the number of seconds, and `mmm' the number of milliseconds.
 * This assumes that the high order bit is zero, so be sure to check this
 * before calling this function since the timestamp is a non-standard value.
 * This timestamp is used by the ICMP timestamp type and the IP timestamp
 * option.
 */
char *ts2asc(u32 ts)
{
    static char asc[] = "xx:xx:xx.xxx";
    int hour, min, sec, msec, zone;

    zone = gmt2local();
    msec = ntohl(ts);
    sec  = msec / 1000;
    sec += zone + 86400;
    min  = sec / 60;
    hour = min / 60;
    msec %= 1000;
    sec  %= 60;
    min  %= 60;
    hour %= 24;
    sprintf(asc, "%02d:%02d:%02d.%03d", hour, min, sec, msec);
    
    return asc;
}
    
